/*
Script: parallelism_Demo1
Author: Manohar Punna
*/

--Create and populate tables script
/*
if exists(select 1 from sys.objects where name like 'Parallel1')
drop table Parallel1
create table Parallel1 (eid int, mid int, name char(200))
 
set nocount on
declare @i int
set @i = 0
while @i < 1000000
  begin
    insert Parallel1 values(@i, @i, @i)
    set @i = @i + 1
  end

select * into Parallel2 from Parallel1
select * into Parallel3 from Parallel1

create unique clustered index CI_Parallel2_eid on Parallel2(eid)
create unique clustered index CI_Parallel3_eid on Parallel3(eid)
*/

--Cost of physical IO > query cost == read ahead
select * from Parallel1

--Introduce Parallelism
select * from Parallel1 where eid < 1000

--load balancing
select * from Parallel1 where eid % 2 = 0 or eid % 2 = 1

/*Nested loop join*/
--Roundrobin
SELECT * FROM Parallel1 P1 JOIN Parallel2 P2 ON P1.mid = P2.eid WHERE P1.eid < 100
--distribute
SELECT * FROM Parallel1 P1 JOIN Parallel2 P2 ON P1.eid = P2.mid WHERE P2.eid =0

/*Hash Join*/
--Parallel Hash
SELECT * FROM Parallel1 P1 JOIN Parallel2 P2 ON P1.mid = P2.eid
--Bitmap filtering
SELECT * FROM Parallel1 P1 JOIN Parallel2 P2 ON P1.eid = P2.mid WHERE P1.mid < 100000
--broadcast
SELECT * FROM Parallel1 P1 JOIN Parallel2 P2 ON P1.eid = P2.mid WHERE P1.mid < 100

/*Aggregations*/
--Global
SELECT eid, MIN(mid) FROM Parallel1 group by eid
--Partial
SELECT MIN(mid) FROM Parallel1