/*First Killer on TOP*/
--Almost Parallel
SELECT 
    P1.eid, 
    SUM(P2.mid) AS mid_sum
FROM Parallel3 AS P1
INNER JOIN Parallel2 AS P2 
	ON P1.eid = P2.mid
WHERE
	P1.eid BETWEEN 1001 AND 10001
GROUP BY
    P1.eid
GO

--TOP
SELECT 
    P1.eid, 
    SUM(P2.mid) AS mid_sum
FROM 
(SELECT TOP(10000) *
 FROM Parallel3
 WHERE
	eid BETWEEN 1001 AND 10001
)AS P1
INNER JOIN Parallel2 AS P2 ON
    P1.eid = P2.mid
GROUP BY
    P1.eid
GO

/*Aggregate - Gathering is tough job*/
--Global Aggregates
SELECT MIN(mid) FROM Parallel1



/*TempDB contention - Temp Variables are better XXXXXXX NOOOOO*/

--Temp table
CREATE TABLE #table(
eid int,
mid int
)

INSERT INTO #table
SELECT 
    P1.eid, 
    SUM(P2.mid) AS mid_sum
FROM Parallel3 AS P1
INNER JOIN Parallel2 AS P2 
	ON P1.eid = P2.mid
WHERE
	P1.eid BETWEEN 1001 AND 10001
GROUP BY
    P1.eid
GO


--Temp Variable
DECLARE @table TABLE (
eid int,
mid_sum int
)

INSERT INTO @table
SELECT 
    P1.eid, 
    SUM(P2.mid) AS mid_sum
FROM Parallel3 AS P1
INNER JOIN Parallel2 AS P2 
	ON P1.eid = P2.mid
WHERE
	P1.eid BETWEEN 1001 AND 10001
GROUP BY
    P1.eid
GO

/*Another Killer - Functions*/

IF (OBJECT_ID('dbo.IamKiller') IS NOT NULL)
	DROP FUNCTION IamKiller
GO

CREATE FUNCTION IamKiller (@bullet INT)
RETURNS INT
AS
BEGIN
	RETURN @bullet
END

--ready to kill
SELECT 
    P1.eid, 
    dbo.IamKiller(SUM(P2.mid)) AS mid_sum
FROM Parallel3 AS P1
INNER JOIN Parallel2 AS P2 
	ON P1.eid = P2.mid
WHERE
	P1.eid BETWEEN 1001 AND 10001
GROUP BY
    P1.eid
GO

--CLR - ready to save

SELECT 
    P1.eid, 
    dbo.IamSaver(SUM(P2.mid)) AS mid_sum
FROM Parallel3 AS P1
INNER JOIN Parallel2 AS P2 
	ON P1.eid = P2.mid
WHERE
	P1.eid BETWEEN 1001 AND 10001
GROUP BY
    P1.eid
GO