USE AdventureWorks2012
GO



--Run each of the following with:
	-- Actual Execution Plan enabled
	-- Client statistics enabled
	-- Discard results after execution 

SELECT
    someweirdthing
FROM bigProduct AS p
CROSS APPLY
(
    SELECT
        DATENAME
        (
			dw, 
			DATEADD
			(
				dd, 
				0, 
				20 % 
					DATEDIFF
					(
						dd, 
						GETDATE()-1, 
						DATEADD
						(
							dd, 
							DATEDIFF
							(
								dd, 
								0, 
								DATEADD
								(
									month, 
									DATEDIFF
									(
										dd, 
										p.SellStartDate, 
										th.TransactionDate
									), 
									DATEADD
									(
										month, 
										DATEDIFF
										(
											month, 
											th.TransactionDate, 
											p.SellStartDate
										), 
										0
									)
								)
							), 
							0
						)
					)
				)
			) AS SomeWeirdThing
    FROM bigTransactionHistory AS th
    WHERE
        th.ProductId = p.ProductId
) AS d
WHERE
    p.ProductId BETWEEN 1001 AND 10001
OPTION (LOOP JOIN)
GO



--CROSS --> OUTER
--Don't forget an IS NOT NULL check!
SELECT
    someweirdthing
FROM bigProduct AS p
OUTER APPLY
(
    SELECT
        DATENAME
        (
			dw, 
			DATEADD
			(
				dd, 
				0, 
				20 % 
					DATEDIFF
					(
						dd, 
						GETDATE()-1, 
						DATEADD
						(
							dd, 
							DATEDIFF
							(
								dd, 
								0, 
								DATEADD
								(
									month, 
									DATEDIFF
									(
										dd, 
										p.SellStartDate, 
										th.TransactionDate
									), 
									DATEADD
									(
										month, 
										DATEDIFF
										(
											month, 
											th.TransactionDate, 
											p.SellStartDate
										), 
										0
									)
								)
							), 
							0
						)
					)
				)
			) AS SomeWeirdThing
    FROM bigTransactionHistory AS th
    WHERE
        th.ProductId = p.ProductId
) AS d
WHERE
    p.ProductId BETWEEN 1001 AND 10001
    AND d.SomeWeirdThing IS NOT NULL
OPTION (LOOP JOIN)
GO
